/*
 *      main.c
 *
 *      Copyright 2008 Link Mauve <linkmauve@free.fr>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "io.h"

void PA_PrintYPlus (u8 screen)
{
	u8 i;
	for(i = pa_printx[screen]; i < 32; i++)
		PA_SetTileLetter(screen, pa_printx[screen], pa_printy[screen]&31, ' ');	// Erase
	pa_printy[screen]++;
	pa_printx[screen] = 0;
	if(pa_printy[screen] > 24)
	{
		pa_printscroll[screen] += 8;
		PA_BGScrollY(screen, PAbgtext[screen], pa_printscroll[screen]);
	}
}

void PA_Print (u8 screen, char* text, ...)
{
	va_list varg;	/* Variable identifiant le prochain paramtre. */
	va_start(varg, text);

	s16 j, i;

	u8 PAtext[32];	// tableau o l'on copie les nombres et tout...
	u8 *PAextext;	// Extra text
	s32 PAtextnumber;
	double tempdouble = 0;

	u8 textcolor = PAtext_pal[screen];

	for (j = 0; text[j]; j++)
	{
		if (text[j] == '%')
		{
			if (text[j+1] == 'c')	// change color !
			{
				PA_SetTextTileCol(screen, text[j+2]-'0');
				j+=2;
			}
			else if (text[j+1] == 's')	// S'il y a %s, c'est une chaine de caractres...
			{
				PAextext = (u8*)va_arg(varg, const u8 *);	// Pointeur vers la chaine de charactres...
				for (i = 0; PAextext[i]; i++)
				{
					if (PAextext[i]=='\n')	//modif Arialia
						PA_PrintYPlus(screen);
					else
						PA_PrintLetter(screen, PAextext[i]);
				}
				j += 1;
			}
			else if ((text[j+1] == 'd') || (text[j+1] == 'f'))
			{
				double test = 0;
				if (text[j+1] == 'd')
				{
					PAtextnumber = va_arg(varg, s32);
					test = PAtextnumber;
				}
				else  // On ne prend que la partie entire pour l'instant, on garde le reste pour plus tard :p
				{
					tempdouble = va_arg(varg, double);
					test = tempdouble;
					PAtextnumber = (s32)tempdouble ;
					tempdouble -= PAtextnumber;
				}

				s8 neg = 0;	// Si negatif, passe  1...
				if (test < 0)
				{
					PAtextnumber = -PAtextnumber;
					neg = 1;
				}

				for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++)	// tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
				{
					PAtext[i] = '0' + (PAtextnumber%10);
					PAtextnumber = PAtextnumber / 10;	// Nombre de dpart...
				}
				if (neg)
				{
					PAtext[i] = '-';
					++i;
				}
				for (i--; i > -1; i--)
					PA_PrintLetter(screen, PAtext[i]);
				j += 1;

				if (text[j] == 'f')	// Il reste donc la virgule  traiter...
				{
					PA_PrintLetter(screen, '.');

					i = text[j+1] - 48;	// Nombre de chiffres aprs la virgule...
					PAtext[1] = 0;	// Permet de stopper si c'est vba...
					if (tempdouble < 0)
						tempdouble = -tempdouble;
					while((i-- > 0))	// Pas plus de 6 chiffres aprs la virgule...
					{
						tempdouble *= 10;
						PAtextnumber = (s32)tempdouble;
						tempdouble -= PAtextnumber;
						PAtext[0] = '0' + PAtextnumber;
						PA_PrintLetter(screen, PAtext[0]);
					}
					j += 1;
				}
			}
			else if ((text[j+3] == 'd') && (text[j+1] != ' ')&& (text[j+2] != ' '))	// C'est plus loin, donc on a genre %02d...
			{
				PAtextnumber = va_arg(varg, s32);
				s8 neg = 0;	// Si negatif, passe  1...
				u8 amettre = text[j+1];	// Nombre  mettre pour remplir
				s8 nfois = text[j+2] - '0';	// Nombre de caractres  mettre

				if (PAtextnumber < 0)
				{
					PAtextnumber = -PAtextnumber;
					neg = 1;
				}

				for (i = 0; PAtextnumber || (!PAtextnumber && !i); i++)	// tant que le nombre ne vaut pas 0 mais que i est positif, on continu  la convertir...
				{
					PAtext[i] = 48 + (PAtextnumber%10);
					PAtextnumber = PAtextnumber / 10;	// Nombre de dpart...
					nfois--;	// Un nombre de moins  mettre...
				}

				while(nfois > 0)	// On complte de 0 est tout...
				{
					PA_PrintLetter(screen, amettre);
					--nfois;
				}

				if (neg)
				{
					PAtext[i] = '-';
					++i;
				}
				for (i--; i > -1; i--)
					PA_PrintLetter(screen, PAtext[i]);
				j += 3;
			}
			else	// Sinon c'est juste
				PA_PrintLetter(screen, text[j]);
		}
		else if (text[j] == '\n')
			PA_PrintYPlus(screen);
		else if ((text[j] == '/') && (text[j+1] == 'n'))
		{
			PA_PrintYPlus(screen);
			j++;
		}
		else
			PA_PrintLetter(screen, text[j]);
	}

	va_end(varg);	/* Terminaison. */

	PA_SetTextTileCol(screen, textcolor);	// put back the old color
}

