/*
 *      main.c
 *
 *      Copyright 2008 Link Mauve <linkmauve@free.fr>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#include "main.h"

#define jid2name(jid,name); strcpy(name,jid); strchr(name,'@')[0]=0;

void changer_status(int numero) /* Change le status */
{
	PA_UpdateSpriteGfx(0, 10, Status[numero].sprite);
	PA_SetSpritePal(0, 10, Status[numero].npal);
	PA_Print(1, "%c4Vous tes maintenant %s.\n", Status[numero].nom);
	if(Status[numero].xml[0] != 0)
		envoyer(Status[numero].xml);
}

void icone_status (void) /* Gre l'icne de status en haut  droite */
{
	PA_WaitForVBL();
	PA_EasyBgLoad(0, 0, status);
	while(1)
	{
		if(Stylus.Newpress)
		{
			if(Stylus.X >= 145 && Stylus.Y >= 16 && Stylus.Y < 94)
			{
				if(Stylus.Y <= 27)
					changer_status(2);
				else if(Stylus.Y <= 38)
					changer_status(3);
				else if(Stylus.Y < 49)
					changer_status(4);
				else if(Stylus.Y < 60)
					changer_status(5);
				else if(Stylus.Y < 71)
					changer_status(6);
				else if(Stylus.Y < 82)
					changer_status(7);
				else
					changer_status(0);
				PA_EasyBgLoad(0, 0, rien);
				break;
			}
			else
			{
				PA_EasyBgLoad(0, 0, rien);
				break;
			}
		}
		recevoir();
		PA_WaitForVBL();
	}
}

void spcat (char *chaine1, const char *chaine2)	/* strcat() transformant les '<' en "&lt;" */
{
	int i = 0;
	int len = strlen(chaine1);

	while(chaine2[i] != 0)
	{
		if(chaine2[i] == '<')
		{
			strcat(chaine1, "&lt;");
			len+=3;
		}
		else
		{
			chaine1[i+len] = chaine2[i];
			chaine1[i+len+1] = 0;
		}
		i++;
	}
}

void recevoir (void) /* Recevoir des donnes */
{
	ezxml_t xml, status;
	char recu[1024] = {0};
	char nom[256];
	s16 taille_recu;

	while((taille_recu = recv(sock, recu, 1023, 0))!=-1)
	{
		if(taille_recu>0)
		{
			recu[taille_recu] = 0;
			xml = ezxml_parse_str(recu, taille_recu);
			jid2name(ezxml_attr(xml, "from"), nom);
			if(!strcmp("message", xml->name))
			{
				if(!strcmp("chat", ezxml_attr(xml, "type")))
					PA_Print(1, "%c1%s%c0 : %s\n", nom, ezxml_child(xml, "body")->txt);
				else if(!strcmp("normal", ezxml_attr(xml, "type")))
					PA_Print(1, "%c1%s%c0 (%s) : %s\n", nom, ezxml_child(xml, "subject")->txt, ezxml_child(xml, "body")->txt);
				PA_PlaySimpleSound(message2);
			}
			else if(!strcmp("presence", xml->name))
			{
				if((status = ezxml_child(xml, "status")) == NULL)
				{
					if(!strcmp("unavailable", ezxml_attr(xml, "type")) || !strcmp("invisible", ezxml_attr(xml, "type")))
					{
						PA_Print(1, "%c6%s s'est dconnect.\n", nom);
						PA_PlaySimpleSound(disconnected);
					}
					else
					{
						if(!strcmp("chat", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s veut discuter.\n", nom);
						else if(!strcmp("away", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s est absent.\n", nom);
						else if(!strcmp("dnd", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s est occup.\n", nom);
						else if(!strcmp("xa", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s n'est pas disponible.\n", nom);
						else
							PA_Print(1, "%c6%s est en ligne.\n", nom);
						PA_PlaySimpleSound(connected);
					}
				}
				else
				{
					if(!strcmp("unavailable", ezxml_attr(xml, "type")) || !strcmp("invisible", ezxml_attr(xml, "type")))
					{
						PA_Print(1, "%c6%s s'est dconnect%c0 : %s\n", nom, status->txt);
						PA_PlaySimpleSound(disconnected);
					}
					else
					{
						if(!strcmp("chat", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s veut discuter%c0 : %s\n", nom, status->txt);
						else if(!strcmp("away", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s est absent%c0 : %s\n", nom, status->txt);
						else if(!strcmp("dnd", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s est occup%c0 : %s\n", nom, status->txt);
						else if(!strcmp("xa", ezxml_txt(ezxml_child(xml, "show"))))
							PA_Print(1, "%c6%s n'est pas disponible%c0 : %s\n", nom, status->txt);
						else
							PA_Print(1, "%c6%s est en ligne%c0 : %s\n", nom, status->txt);
						PA_PlaySimpleSound(connected);
					}
				}
			}
			else if(!strcmp("iq", xml->name))
			{
				if(!strcmp("get", ezxml_attr(xml, "type")))
				{
					if(!strcmp("get", ezxml_txt(ezxml_child(xml, "query"))))
					{
						if(!strcmp("jabber:iq:version", ezxml_attr(ezxml_child(xml, "query"), "xmlns")))
						{
							sprintf(chaine, "<iq to='%s' from='%s' id='%s' type='result'><query xmlns='jabber:iq:version'><name>JabberDS</name><version>0.1b</version><os>Nintendo DS</os></query></iq>", dest, jid, ezxml_attr(xml, "id"));
							envoyer(chaine);
						}
						else if(!strcmp("jabber:iq:last", ezxml_attr(ezxml_child(xml, "query"), "xmlns")))
						{
							sprintf(chaine, "<iq to='%s' from='%s' id='%s' type='result'><query seconds='0' xmlns='jabber:iq:last'/></iq>", dest, jid, ezxml_attr(xml, "id"));
							envoyer(chaine);
						}
						/* else
						{
							crire qu'on ne supporte pas cette fonctionnalit.
						} */
					}
				}
			}
		}
	}
}

void login (int visible, char *question)	/* Demande une information  l'utilisateur */
{
	char aff[256] = {0};
	s32 nletter = 0;
	char letter = 0;
	int i;

	chaine[0] = 0;

	PA_Print(1, "Veuillez entrer votre %s.\n", question);

	while (1)
	{
		letter = PA_CheckKeyboard();

		if (letter >= 0x20) {
			chaine[nletter] = letter;
			nletter++;
			chaine[nletter] = 0;
		}
		else if ((letter == PA_BACKSPACE)&&nletter) {
			nletter--;
			chaine[nletter] = 0;
		}
		else if (letter == '\n'){
			chaine[nletter] = 0;
			PA_WaitForVBL();
			break;
		}

		PA_ClearTextBg(0);
		if(visible)	/* Ce n'est pas un mot de passe,	*/
		{		/* on peut afficher les caractres	*/
			PA_BoxText(0, 3, 3, 28, 9, chaine, 156);
		}
		else
		{
			aff[0] = 0;
			for(i=0; chaine[i] != 0; i++)
				strcat(aff, "*");
			PA_BoxText(0, 3, 3, 28, 9, aff, 156);
		}

		PA_WaitForVBL();
	}
}

void connexion (void)	/* Gre toute la procdure de connexion */
{
	FILE *fichier = NULL;
	char buff[512] = {0};
	char jid[256] = {0};
	ezxml_t xml;
	int c, i=-1;
	char *suite;

	if (fatInitDefault() && (fichier=fopen("jds.xml", "r")) != NULL)
	{
		while(i++ != 512 && (c = fgetc(fichier)) != EOF)
			buff[i] = c;
		buff[i] = 0;
		fclose(fichier);
		xml = ezxml_parse_str(buff, i);
		strcpy(jid, ezxml_child(xml, "jid")->txt);
		jid2name(jid,username);
		suite = strchr(jid, '@');
		strcpy(serveur, suite + 1);
		strcpy(password, ezxml_child(xml, "passwd")->txt);
	}
	else
	{
		PA_Print(1, "chec de l'ouverture de jds.xml.\n");
		mjid:;
		login(1, "JID");
		strcpy(jid, chaine);
		if((suite = strchr(jid, '@')) == NULL || strchr(jid, '/') != NULL)
		{
			PA_Print(1, "Mauvais JID.\n");
			goto mjid;
		}
		suite[0] = 0;
		strcpy(username, chaine);
		strcpy(serveur, suite + 1);
		login(0, "mot de passe");
		strcpy(password, chaine);
	}
	strcat(jid, "/DS");

	login(1, "destinataire");
	strcpy(dest, chaine);

	jid2name(dest, destname);

	PA_Print(1, "JID : %s\n", jid);
	PA_Print(1, "username : %s\n", username);
	PA_Print(1, "serveur : %s\n", serveur);
	PA_Print(1, "dest : %s\n", dest);
	PA_Print(1, "destname : %s\n", destname);

	changer_status(1);
	PA_ConnectWifiWFC();
	PA_InitSocket(&sock, serveur, port, PA_NONBLOCKING_TCP);

	sprintf(chaine, "<?xml version='1.0' encoding='UTF-8'?><stream:stream xmlns:stream='http://etherx.jabber.org/streams' version='1.0' xmlns='jabber:client' to='%s' ><iq type='set' id='Authentification' to='%s' ><query xmlns='jabber:iq:auth'><username>%s</username><password>%s</password><resource>%s</resource></query></iq>", serveur, serveur, username, password, resource);
	envoyer(chaine);

	recevoir();

	changer_status(2);

	for(i=0; i<30; i++)PA_WaitForVBL();

	recevoir();
}

void jabber (void) /* Gre l'emission des messages */
{
	char msg[256] = {0};
	s32 nletter = 0;
	char letter = 0;

	while (1)
	{
		letter = PA_CheckKeyboard();

		if (letter >= 0x20) {
			msg[nletter] = letter;
			nletter++;
			msg[nletter] = 0;
		}
		else if ((letter == PA_BACKSPACE)&&nletter) {
			nletter--;
			msg[nletter] = 0;
		}
		else if (letter == '\n'){
			PA_PlaySimpleSound(sent);
			sprintf(chaine, "<message to='%s' type='chat'><body>%s</body></message>", dest, msg);
			envoyer(chaine);
			PA_Print(1, "%c3%s%c0 : %s\n", username, msg);
			nletter = 0;
			msg[nletter] = 0;
		}

		PA_ClearTextBg(0);
		PA_BoxText(0, 3, 3, 28, 9, msg, 156);
		PA_OutputText(0, 0, 23, "%s", dest);

		recevoir();

		if(Stylus.Newpress)
		{
			if(Stylus.X >= 240 && Stylus.Y < 16)
			{
				icone_status();
			}
			else if( /* Stylus.Y >= 8 && */ Stylus.Y < 24)
			{
				/* if(Stylus.X >= 24 && Stylus.X < 40)
				{
					Contact prcdent.
				}
				else if(Stylus.X >= 40 && Stylus.X < 56)
				{
					Contact suivant.
				} */
				if(Stylus.X >= 24 && Stylus.X < 56)
				{
					login(1, "nouveau destinataire");
					strcpy(dest, chaine);
					jid2name(dest, destname);
				}
			}
		}

		PA_WaitForVBL();
	}
}

int main (int argc, char ** argv)	/* Point d'entre du programme */
{
	u8 i;

	PA_Init();	/* PAlib */
	PA_InitVBL();

	/* Texte */
	PA_InitText(1, 0);
	PA_InitText(0, 1);

	/* PA_InitCustomText(1, 0, font);
	PA_InitCustomText(0, 1, font); */

	PA_InitWifi();	/* Wifi */
	PA_InitSound();	/* Sons */

	PA_EasyBgLoad(0, 3, contact);
	PA_InitKeyboard(2);
	PA_ScrollKeyboardXY(24, 80);

	for(i = 0; i < 8; i++)
		PA_LoadSpritePal(0, Status[i].npal, Status[i].palette);

	PA_CreateSprite(0, 10, Status[0].sprite, OBJ_SIZE_16X16, 1, 0, 240, 0);

	connexion();
	jabber();

	while (1)
		PA_WaitForVBL();

	return 0;
}

