/*
 *      main.c
 *
 *      Copyright 2008 Link Mauve <linkmauve@free.fr>
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

#ifndef MAIN_H
#define MAIN_H

#include <PA9.h>
#include <stdio.h>
#include <string.h>
#include <fat.h>

/* Police */
// #include "font/all_gfx.h"
// #include "font/all_gfx.c"

/* Images */
#include "discussion/all_gfx.h"
#include "discussion/all_gfx.c"

#include "status/all_gfx.h"
#include "status/all_gfx.c"

/* Sons */
#include "connected.h"
#include "disconnected.h"
#include "message1.h"
#include "message2.h"
#include "sent.h"

/* Parsage du XML */
#include "ezxml.h"

/* Fonction PA_Print */
#include "io.h"

int sock;
char chaine[1024] = {0};

/* Variables globales d'identification */
char serveur[256];
int port = 5222;
char username[256];
char password[256];
char * resource = "DS";
char jid[256];

char dest[256];
char destname[256];

/*
typedef struct {
	u8 numero;	// Numro
	char *jid;	// JID
	char *nom;	// Nom
} contact_t;
*/

typedef struct {
	u8 npal;	// Numro de palette
	void *palette;	// Palette
	void *sprite;	// Image
	char *nom;	// Nom
	char *xml;	// XML  envoyer
} status_t;

status_t Status[8] = {
	{0, (void*)offline_Pal,		(void*)offline_Sprite,		"hors ligne",			"<presence type='unavailable' />"},
	{1, (void*)connecting_Pal,	(void*)connecting_Sprite,	"en connexion",			""},
	{2, (void*)online_Pal,		(void*)online_Sprite,		"en ligne",			"<presence />"},
	{3, (void*)chat_Pal,		(void*)chat_Sprite,		"disponible pour discuter",	"<presence><show>chat</show></presence>"},
	{4, (void*)away_Pal,		(void*)away_Sprite,		"absent",			"<presence><show>away</show></presence>"},
	{5, (void*)xa_Pal,		(void*)xa_Sprite,		"non disponible",		"<presence><show>xa</show></presence>"},
	{6, (void*)dnd_Pal,		(void*)dnd_Sprite,		"occup",			"<presence><show>dnd</show></presence>"},
	{7, (void*)invisible_Pal,	(void*)invisible_Sprite,	"invisible",			"<presence type='invisible' />"},
};

void changer_status (int j);
void icone_status (void);

void spcat (char *chaine1, const char * chaine2);
void recevoir (void);

void parse (ezxml_t xml);
void login (int visible, char *question);
void connexion (void);
void jabber (void);

int main (int argc, char ** argv);

#endif // MAIN_H

